/* -----------------------------------------------------!
! The current OpenMP code is to:                        !
! (1) demonstrate firstprivate variables.               !
! (2) reduction variables.                              !
! (3) fixed the incorrect 'totsum' in v0.               !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! April 17, 2017                                        !
!----------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main () 
{
    int i,id,nosize,noprocs;
    const int  nsize = 50;
    double temp,totsum,answer;
    double array_a[nsize];


    nosize = nsize;
    for( i = 0; i < nosize; i++ ) { array_a[i] = (double) i; }
    
    totsum = 0.0;

#pragma omp parallel for default(none) private(i) shared(nosize,array_a) \
        reduction(+: totsum)
    for( i = 0; i < nosize; ++i ) { totsum += array_a[i]; }
   

    answer = (double) 0.5*(nsize-1)*nsize;
    printf("totsum = %12.2f\n", totsum);
    printf("correct answer = %12.2f\n", answer);

}

