/*  ------------------------------------------------------- !
! The current OpenMP is to:                                 !
! (1) define a simple parallel region.                      !
! (2) demonstrate a private variable.                       !
! (3) get each thread ID.                                   !
! (4) detect the number of available processors (cores).    !
! (5) get the number of the threads.                        !
! (6) show different behaviors of Intel, PGI, and GCC.      !
!-----------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                   !
! March 10, 2017                                            !
!--------------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>

int main () {

int id,noprocs,nothread;

#pragma omp parallel
{
  id = omp_get_thread_num();         // thread ID.
  noprocs = omp_get_num_procs();     // get numner of "processors" (cores).
  nothread = omp_get_num_threads();  // number of the threads.
  printf("Hello World! from %3d %3d %3d\n", id, nothread, noprocs);
}

}
