/*  ---------------------------------------------- !
! The current OpenMP code has the purpose:         !
! (1) defensive programming.                       !
! (2) conditional compilation.                     !
! (3) macro for the gcc compiler.                  !
!--------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                          !
! March 11, 2017                                   !
!-------------------------------------------------*/

#ifdef _OPENMP
#include <omp.h>
#endif

#include <stdio.h>
#include <stdlib.h>

int main () {

int id;
#ifdef _OPENMP
  #pragma omp parallel
  {
   id = omp_get_thread_num();
   printf("Hello World from %3d!\n", id);
  }
#else
  id = 0;
  printf("Hello World from %3d!\n", id);
#endif


}
