/*  ------------------------------------------------------- !
! The current OpenMP code is to:                            !
! (1) see how to parallalize nested loops.                  !
! (2) see which loop should or should not be parallelized.  !
! (3) use a naive version of matrix-matrix product.         !
! (4) see how to fix the incorrect variable.                !
!-----------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                   !
! March 20, 2017                                            !
!--------------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


int main () {

   int i,j,k,id,nothread,nosize,index,inda,indb;
   const int nsize = 4000, nsize2 = nsize*nsize;
   double tsum,time_start,time_end;
   double a[nsize2],b[nsize2],c[nsize2];


   nosize = nsize;
   index = -1;
/* initialize arrays: a, b, and c:   */
   for(i = 0; i < nosize; i++)  {
   for(j = 0; j < nosize; j++)  {
       index += 1;
       a[index] = sin( (double) (i-j) );
       b[index] = cos( (double) (i+j) );
/*       c[index] = 0.0;   */
     } }


time_start = omp_get_wtime();

/* only parallelize the outer loop with ijk: */
   for(i = 0; i < nosize; i++)  { 
   for(j = 0; j < nosize; j++)  { 
           index = i*nosize + j;
           tsum = 0.0; 
#pragma omp parallel for default(none) private(i,j,k,inda,indb) shared(nosize,a,b,c) reduction(+:tsum)
       for(k = 0; k < nosize; k++)  { 
           inda =  i*nosize + k;
           indb =  k*nosize + j;
           tsum += a[inda] * b[indb]; 
           }
       c[index] = tsum;
   } } 


time_end = omp_get_wtime();

printf("c[0] = %15.5f\n",c[0]);
printf("elapsed time (second) = %.5f\n", time_end - time_start);


}
