/*  --------------------------------------------------- !
! The current OpenMP code is to:                        !
! (1) see non-deterministic behavior in FP operation.   !
! (2) use a reduction variable.     !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 20, 2017                                        !
!----------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>


int main () {

   int i,nosize;
   const int nsize = 100;
   double temp,time_start,time_end;
   double a[nsize],b[nsize],c;


   nosize = nsize;
/* initialize arrays: a, b, and c:   */
/* coulumn: j and row: i. */
   for(i = 0; i < nosize; i++)  {
       a[i] = sin( (double) i );
       b[i] = cos( (double) i );
     } 


time_start = omp_get_wtime();

   c = 0.0;
#pragma omp parallel for default(none) private(i) shared(nosize,a,b) reduction(+: c)
   for(i = 0; i < nosize; i++)  { 
       c += a[i] + b[i];
   } 


time_end = omp_get_wtime();

printf("c = %27.20e\n",c);
printf("elapsed time (second) = %.5f\n", time_end - time_start);


}
