/* -----------------------------------------------------!
! The current OpenMP is to:                             !
! (1) use Intel and GCC compilers and see how           !
!     OMP_NUM_THREADS was set by default.               !  
! (2) demonstrate how private variables behave outside  !
!     of parallell regions.                             !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! April 19, 2017                                        !
!----------------------------------------------------- */

#include <omp.h>
#include <stdio.h>
#include <stdlib.h>
#define nsize 410


/* global variables */
int id, istart,iend;
double array_a[nsize],array_b[nsize];
#pragma omp threadprivate (id,istart,iend) 
/* end of global variables */


int main () {

int i,nothread,nchunk;


   for(i = 0; i < nsize; i++ ) 
   {
      array_a[i] = (double) i;
      array_b[i] = (double) (i+i);
   }


#pragma omp parallel
    {
      nothread = omp_get_num_threads();
      id = omp_get_thread_num();
      nchunk = (double)(nsize) / (double)(nothread);
      istart = 1 + id*nchunk;
      iend = istart + nchunk - 1;
      if(id == nothread-1) {
         istart = 1 + id*nchunk;
         iend = nsize;
         nchunk = iend - istart + 1;
        }
         printf("Hello from %5d %5d %5d\n", id, istart, iend);
    }

       printf("\n");
       printf("Hello from master. id = %d\n", id);


#pragma omp parallel 
    {
       printf("Hello from %5d %5d %5d\n", id, istart, iend);
    }


}



