!-------------------------------------------------------!
! The current OpenMP code is to:                        !
! (1) use atomic (critical) directive.                  !
! (2) sum over from 1 to nsize.                         !
! (3) precision: real DP.                               !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! April 02, 2017                                        !
!-------------------------------------------------------!

      program atomic
      implicit none
      integer, parameter  :: idp=8,nsize = 1000
      integer ::  i,id
      real(kind=idp)  :: x, answer



!$omp parallel private (i) shared(x)
!$omp do
      do i = 1, nsize
!$omp atomic
         x = x + dble(i)
      end do
!$omp end do
!$omp end parallel

      answer = 0.5_idp * (nsize+1)*nsize
      write(*,'(a,f10.2)') 'parallel sum is ',x
      write(*,'(a,f10.2)') 'correct answer is ', answer


      end program atomic
