!----------------------------------------------------------------!
! The current OpenMP code is to:                                 !
! (1) count to the number of even integer in a matrix.           !
! (2) demonstrate the false sharing issues.                      !
! (3) precision: integer.                                        !
!----------------------------------------------------------------!
! this is the serial version v0.                                 !
!----------------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                        !
! March 18, 2017                                                 !
!----------------------------------------------------------------!

      program false_sharing_v0
      implicit none
      integer                                 :: i,j,nosize,counter_even,itmp
      integer, parameter                      :: nsize = 10000
      real(kind=8)                            :: tmp,time_start,time_end,omp_get_wtime
      integer, dimension(0:nsize-1,0:nsize-1) :: matrix

! initialize the matrix.
      nosize = nsize
      do i = 0, nosize-1
      do j = 0, nosize-1
         tmp = dble(i*j+1) / dble(i+j+1)
         matrix(j,i) = int(tmp)
      end do
      end do


      time_start = omp_get_wtime()
! count the number of even integers.
         counter_even = 0
      do i = 0, nosize-1
      do j = 0, nosize-1
         itmp = mod(matrix(j,i),2)
         if (itmp == 0) counter_even = counter_even + 1
      end do
      end do

      time_end = omp_get_wtime()
      write(*,'(1x,a,i12)') "Number of even integers is ", counter_even
      write(*,'(1x,a,f10.5)') "Elapsed time (sec) is ", time_end - time_start


      end program false_sharing_v0

