!-------------------------------------------------------!
! The current OpenMP code is to:                        !
! (1) use Intel and GCC compilers and see how           !
!     OMP_NUM_THREADS was set by default.               !  
! (2) demonstrate how private variables behave outside  !
!     of parallell regions.                             !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 11, 2017                                        !
!-------------------------------------------------------!

      program privatevar
      implicit none
      integer   :: k,id,nothread,omp_get_num_threads,omp_get_thread_num


!$omp parallel private (k,id)
       nothread = omp_get_num_threads() 
       id = omp_get_thread_num()
       k = id + id
!$omp end parallel


       write(*,'(a,i3)') 'Hello from the master. k = ', k


!$omp parallel private (k,id)
       write(*,'(a,i3,2x,i3,2x,i3)') 'Hello: ', id, k, nothread
!$omp end parallel


      end program privatevar


