!=======================================================!
! The current OpenMP code is to:                        !
! (1) see non-deterministic behavior in FP operation.   !
! (2) use a reduction variable.                         !
!-------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                               !
! March 20, 2017                                        !
!=======================================================!

      program sum_order
      implicit none

      integer             :: i,nosize
      integer, parameter  :: nsize = 100
      real(kind=8), dimension(:)  :: a(0:nsize-1),b(0:nsize-1)
      real(kind=8)        :: c,time_start,time_end,omp_get_wtime


      nosize = nsize;
   
! initialize arrays: a and b.
      do i = 0, nosize-1
         a(i) = sin( dble(i) )
         b(i) = cos( dble(i) )
      end do

      time_start = omp_get_wtime()

         c = 0.d0
!$omp parallel do private(i) shared(nosize,a,b) reduction(+:c)
      do i = 0, nosize-1
         c = c +  a(i) + b(i)
      end do

      time_end = omp_get_wtime()
      write(*,'(a,es27.20)') 'c = ', c

      write(*,'(a,f10.5)') 'elapsed time (second) = ', time_end - time_start


      end program sum_order

