!------------------------------------------------------------!
! The current OpenMP code is to:                             !
! (1) use Intel and GCC compilers and see how                !
!     OMP_NUM_THREADS was set by default.                    !  
! (2) use threadprivate variable in the same program unit.   !
!------------------------------------------------------------!
! Xiaoxu Guan at LSU HPC.                                    !
! April 20, 2017                                             !
!------------------------------------------------------------!

      module thpr
      implicit none
      integer            :: id,istart,iend
      integer, parameter :: idp = 8, nsize = 410 
      real(kind=idp) :: array_a(1:nsize),array_b(1:nsize),array_c(1:nsize)
!$omp threadprivate (id,istart,iend)
      end module thpr


      program threadprivate_v1
      use thpr
      implicit none
      integer   :: i,nothread,nchunk,omp_get_num_threads,omp_get_thread_num

         array_c = 0.0_idp
      do i = 1, nsize
         array_a(i) = dble(i)
         array_b(i) = dble(i+i)
      end do


!$omp parallel
         nothread = omp_get_num_threads() 
         id = omp_get_thread_num()
         nchunk = dble(nsize)/dble(nothread)
         istart = 1 + id*nchunk
         iend = istart + nchunk - 1
      if(id == nothread-1) then
         istart = 1 + id*nchunk
         iend = nsize
         nchunk = iend - istart + 1
      end if
         write(*,'(1x,a,3(i3,3x))') 'Hello from ', id, istart, iend
!$omp end parallel

      write(*,*)
      write(*,'(1x,a,i3)') 'Hello I am master. id = ', id
      write(*,*)


!$omp parallel 
      write(*,'(1x,a,3(i3,3x))') 'Hello from ', id, istart, iend
!$omp end parallel


      end program threadprivate_v1

